package com.emamaker.voxeltest.intervaltrees.utils;

public class Utils {

    public static boolean withinDistance(int startx, int starty, int startz, int x, int y, int z, int dist) {
        return (x-startx)*(x-startx) + (y - starty)*(y-starty) + (z-startz)*(z-startz) <= dist*dist;
    }
    // https://stackoverflow.com/questions/20266201/3d-array-1d-flat-indexing
    //flatten 3d coords to 1d array cords
    public static int coord3DTo1D (int x, int y, int z, int maxX, int maxY, int maxZ){
        return x + maxX * (y + z * maxY);
    }

    // To check if this actually works
    public static int[] coord1DTo3D(int idx, int maxX, int maxY, int mazZ){
        final int z = idx / (maxX * maxY);
        idx -= (z * maxX* maxY);
        final int y = idx / maxX;
        final int x = idx % maxX;
        return new int[]{ x, y, z }; 
    }
}
